function bayes_risk(rules,range,loss,ratio)
    fname  = strcat('../results/bayes_risk_withX_',loss,'_loss_ratio',num2str(10*ratio),'.csv');
    header = strcat('rule,a_w_h,a_w_l,a_b_h,a_b_l,c_w_h,c_w_l,c_b_h,c_b_l,freq,post,e_logit,risk');

    f = fopen(fname,'w');
    fprintf(f,'%s\n',strcat(header));
    fclose(f);

    if     strcmp(loss,'errors')
        rules = sortrows(rules,'post'   ,'descend');
    elseif strcmp(loss,'logit1')
        rules = sortrows(rules,'e_logit','descend');
    elseif strcmp(loss,'logit2')
        rules = sortrows(rules,'post'   ,'descend');
    end

    g = logit1(1,ratio) - rules.e_logit;
    q = rules.post;
    o = (logit1(4.0574,1)-0.5)*(ratio - q); % hard-codes estimate of beta_0

    for i = 1:height(rules)
        p(i,1) = rules.f(i).*nchoosek(5,rules.a_w_h(i)).*nchoosek(5,rules.a_b_h(i))/(2^10);
    end

    m = zeros(size(rules.f));
    for i = 1:range(2)
        disp(['Rule ',num2str(i),':'])
        m(i) = 1;
        if i >= range(1)
            if     strcmp(loss,'errors')
                risk(i,1) = 100*((m.*p)'*(ratio*(1-q)) + ((1-m).*p)'*((1-ratio)*q));
            elseif strcmp(loss,'logit1')
                risk(i,1) = 100*((m.*p)'*g);
            elseif strcmp(loss,'logit2')
                risk(i,1) = 100*((m.*p)'*o);
            end
            dlmwrite(fname,[i table2array(rules(i,:)) risk(i,1)],'-append');
        end
    end
end
