function compute_bounds_withX(data,grid,ratio)
    fname  = strcat('../results/bounds_withX.csv');
    header = strcat('Upper Bound, Lower Bound, UB Pr(Innocent), LB Pr(Innocent)');
    f = fopen(fname,'w');
    fprintf(f,'%s\n',strcat(header));
    fclose(f);

    u = ones( 1,height(grid));
    l = zeros(1,height(grid));
    for i = 1:height(data)
        mm(i,:) = (binopdf(data.c_w_l(i),data.a_w_l(i),grid.p_w_l).* ...
                   binopdf(data.c_w_h(i),data.a_w_h(i),grid.p_w_h).* ...
                   binopdf(data.c_b_l(i),data.a_b_l(i),grid.p_b_l).* ...
                   binopdf(data.c_b_h(i),data.a_b_h(i),grid.p_b_h)   )';
    end;
    A = [u;mm(    data.c_w_l+data.c_w_h+data.c_b_l+data.c_b_h>0,:)];
    b = [1;data.f(data.c_w_l+data.c_w_h+data.c_b_l+data.c_b_h>0)  ];

    q = (grid.p_w_h <= grid.p_b_h & grid.p_w_l <= grid.p_b_l)';
    e = (ratio)*(q) + (1-ratio)*(1-q);
    g = logit1(u,u*ratio)                - logit1(grid.p_w_h+grid.p_w_l,grid.p_b_h+grid.p_b_l)';
    o = 0.5+(logit1(4.0574,1)-0.5)*ratio - logit2(grid.p_w_h,grid.p_w_l,grid.p_b_h,grid.p_b_l)';
    D = grid.G;

    [G_ub, r_ub] = linprog_gurobi_withX(-100*(q),[],[],A,b,l,u);
    [G_lb, r_lb] = linprog_gurobi_withX( 100*(q),[],[],A,b,l,u);
    dlmwrite(fname,[-r_ub r_lb q*G_ub q*G_lb],'-append');

    [G_ub, r_ub] = linprog_gurobi_withX(-100*(e),[],[],A,b,l,u);
    [G_lb, r_lb] = linprog_gurobi_withX( 100*(e),[],[],A,b,l,u);
    dlmwrite(fname,[-r_ub r_lb q*G_ub q*G_lb],'-append');


    [G_ub, r_ub] = linprog_gurobi_withX(-100*(g),[],[],A,b,l,u);
    [G_lb, r_lb] = linprog_gurobi_withX( 100*(g),[],[],A,b,l,u);
    dlmwrite(fname,[-r_ub r_lb q*G_ub q*G_lb],'-append');


    [G_ub, r_ub] = linprog_gurobi_withX(-100*(o),[],[],A,b,l,u);
    [G_lb, r_lb] = linprog_gurobi_withX( 100*(o),[],[],A,b,l,u);
    dlmwrite(fname,[-r_ub r_lb q*G_ub q*G_lb],'-append');
end
