function bounds = lp_bounds_sep(data,bb,p_w,p_b)
    % Read in data
    N_w = data(:,1);
  	N_b = data(:,2);
	  C_w = data(:,3);
	  C_b = data(:,4);

    % Construct probability grid and constraint matrix
	  for i = 1:length(bb)
	    t = binopdf(C_w(i),N_w(i),p_w).*binopdf(C_b(i),N_b(i),p_b);
	    mm(i,:) = t';
    end

    % Construct constraint matrices
    m = mm(C_w + C_b > 0,:);
    b = bb(C_w + C_b > 0);
    u = ones( size(p_b))';
    l = zeros(size(p_b))';

    % Estimate bounds
    for i = 1:length(bb)
        [~, bounds_tr(i,1)] = linprog_gurobi(-mm(i,:)'.*(p_w == p_b),[],[],[m;u],[b;1],l,u);
        [~, bounds_lt(i,1)] = linprog_gurobi(-mm(i,:)'.*(p_w <= p_b),[],[],[m;u],[b;1],l,u);
        [~, bounds_ut(i,1)] = linprog_gurobi(-mm(i,:)'.*(p_w >= p_b),[],[],[m;u],[b;1],l,u);
    end

    bounds = [data -bounds_tr./bb -bounds_lt./bb -bounds_ut./bb]
end
