function lp_minimax_G(data,grid,rules,range,loss,ratio)
    fname  = strcat('../results/minimax_G_withX_',loss,'_loss_ratio',num2str(10*ratio),'.csv');
    header = strcat('p_w_h,p_b_h,p_w_l,p_b_l,G');

    if     strcmp(loss,'errors')
        rules = sortrows(rules,'post'   ,'descend');
    elseif strcmp(loss,'logit')
        rules = sortrows(rules,'e_logit','descend');
    elseif strcmp(loss,'logit2')
        rules = sortrows(rules,'post'   ,'descend');
    end

    u = ones( 1,height(grid));
    l = zeros(1,height(grid));
    for i = 1:height(data)
        mm(i,:) = (binopdf(data.c_w_l(i),data.a_w_l(i),grid.p_w_l).* ...
                   binopdf(data.c_w_h(i),data.a_w_h(i),grid.p_w_h).* ...
                   binopdf(data.c_b_l(i),data.a_b_l(i),grid.p_b_l).* ...
                   binopdf(data.c_b_h(i),data.a_b_h(i),grid.p_b_h)   )';
    end;
    A = [u;mm(    data.c_w_l+data.c_w_h+data.c_b_l+data.c_b_h>0,:)];
    b = [1;data.f(data.c_w_l+data.c_w_h+data.c_b_l+data.c_b_h>0)  ];

    q = (grid.p_w_h <= grid.p_b_h & grid.p_w_l <= grid.p_b_l)';
    g = logit1(u,u*ratio)                - logit1(grid.p_w_h+grid.p_w_l,grid.p_b_h+grid.p_b_l)';
    o = 0.5+(logit1(4.0574,1)-0.5)*ratio - logit2(grid.p_w_h,grid.p_w_l,grid.p_b_h,grid.p_b_l)';
        % hard-codes estimate of beta_0

    m = l;
    for i = 1:range
        disp(['Rule ',num2str(i),':'])
        m          = m + (binopdf(rules.c_w_l(i),rules.a_w_l(i),grid.p_w_l).* ...
                          binopdf(rules.c_w_h(i),rules.a_w_h(i),grid.p_w_h).* ...
                          binopdf(rules.c_b_l(i),rules.a_b_l(i),grid.p_b_l).* ...
                          binopdf(rules.c_b_h(i),rules.a_b_h(i),grid.p_b_h) * ...
                          nchoosek(5,rules.a_w_h(i))*nchoosek(5,rules.a_b_h(i))/(2^10))';
        if i == range
            if     strcmp(loss,'errors')
                [G, r] = linprog_gurobi_withX(-100*((ratio)*(q).*m + (1-ratio)*(1-q).*(1-m)),[],[],A,b,l,u);
            elseif strcmp(loss,'logit1')
                [G, r] = linprog_gurobi_withX(-100*(m.*g),[],[],A,b,l,u);
            elseif strcmp(loss,'logit2')
                [G, r] = linprog_gurobi_withX(-100*(m.*o),[],[],A,b,l,u);
            end
            disp(strcat('Risk (', loss,' loss) ', num2str(-r)))
            disp(strcat('% Innocent (', loss,' loss) ', num2str(q*G)))

            outsheet([grid.p_w_h grid.p_b_h grid.p_w_l grid.p_b_l G],header,fname)
        end
    end
end
