function [G J] = qcqp_gurobi(W,f,A,b,Aeq,beq,lb,ub,Qc,J)
    model.Q     = sparse(W);
    model.A     = sparse(Aeq)
    model.rhs   = [beq];
    model.sense = '=';
    model.lb    = lb;

    model.quadcon(1).q     = zeros(size(lb));
    model.quadcon(1).Qc    = sparse(Qc);
    model.quadcon(1).rhs   = J;
    model.quadcon(1).sense = '<';

    if length(f)  > 0
        model.obj = f;
    end

    if length(ub) > 0
        model.ub = ub;
    end

    params.NumericFocus = 3;
    params.quad         = 1;

    results = gurobi(model,params);
    G       = results.x;
    J       = results.objval
end
