function [G J] = quadprog_gurobi(W,f,A,b,Aeq,beq,lb,ub)
    model.Q     = sparse(W);
    model.A     = sparse(Aeq)
    model.rhs   = [beq];
    model.sense = '=';
    model.lb    = lb;

    if length(f)  > 0
        model.obj = f;
    end

    if length(ub) > 0
        model.ub = ub;
    end

    params.NumericFocus = 3;
    params.quad         = 1;

    results = gurobi(model,params);
    G       = results.x;
    J       = results.objval
end
