function [centered key] = recenter_nunley(moments)
    p_w = moments(:,1);
    p_b = moments(:,2);
    mu  = moments(:,4);
    mc  = zeros(size(mu));
    mm  = zeros(max(p_w)+1,max(p_b)+1);
    for i = 1:length(mu)
        mm(p_w(i)+1,p_b(i)+1) = mu(i);
    end
    m   = @(i,j)(mm(i+1,j+1));

    mc(p_w == 1 & p_b == 0) = m(1,0)                                        ;
    mc(p_w == 2 & p_b == 0) = m(2,0) - m(1,0)^2                             ;
    mc(p_w == 3 & p_b == 0) = m(3,0) - 3*m(2,0)^2*m(1,0) + 2*m(1,0)^3       ;
    mc(p_w == 0 & p_b == 1) = m(0,1)                                        ;
    mc(p_w == 1 & p_b == 1) = m(1,1) - m(1,0)*m(0,1)                        ;
    mc(p_w == 2 & p_b == 1) = m(2,1) - 2*m(1,0)*m(1,1) - m(0,1)*(m(2,0)     ...
                            - m(1,0)^2)                                     ;
    mc(p_w == 3 & p_b == 1) = m(3,1) - 3*m(1,0)*m(2,1) + 3*m(1,0)^2*m(1,1)  ...
                            - m(1,0)^3*m(0,1) - m(3,0)*m(0,1)               ...
                            + 3*m(1,0)*m(0,1)*m(2,0) - 2*m(1,0)^3*m(0,1)    ;
    mc(p_w == 0 & p_b == 2) = m(0,2) - m(0,1)^2                             ;
    mc(p_w == 1 & p_b == 2) = m(1,2) - 2*m(0,1)*m(1,1) - m(1,0)*(m(0,2)     ...
                            - m(0,1)^2)                                     ;
    mc(p_w == 2 & p_b == 2) = m(2,2) - 2*m(1,0)*m(1,2) + m(1,0)^2*m(0,2)    ...
                            - 2*m(0,1)*m(2,1) + 4*m(1,0)*m(0,1)*m(1,1)      ...
                            + m(2,0)*m(0,1)^2 - m(1,0)^2*m(0,1)^2           ;
    mc(p_w == 0 & p_b == 3) = m(0,3) - 3*m(0,2)^2*m(0,1) + 2*m(0,1)^3       ;
    mc(p_w == 1 & p_b == 3) = m(1,3) - 3*m(0,1)*m(1,2) + 3*m(0,1)^2*m(1,1)  ...
                            - m(0,1)^3*m(1,0) - m(0,3)*m(1,0)               ...
                            + 3*m(0,1)*m(1,0)*m(0,2) - 2*m(0,1)^3*m(1,0)    ;

    mean_p_w = m(1,0);
    sdev_p_w = sqrt(m(2,0)-m(1,0)^2);
    mean_p_b = m(0,1);
    sdev_p_b = sqrt(m(0,2)-m(0,1)^2);
    mean_dif = m(1,0)-m(0,1);
    sdev_dif = sqrt(m(2,0)-m(1,0)^2 + m(0,2)-m(0,1)^2 - 2*(m(1,1)-m(1,0)*m(0,1)));
    corr_p_w = 1;
    corr_p_b = (m(1,1)-m(1,0)*m(0,1))/(sdev_p_b*sdev_p_w);
    corr_dif = (m(1,1)-m(1,0)*m(0,1)-m(2,0)+m(1,0)^2)/(-sdev_dif*sdev_p_w);
    skew_p_w = (m(3,0) - 3*m(2,0)^2*m(1,0) + 2*m(1,0)^3)/sdev_p_w^3;
    skew_p_b = (m(0,3) - 3*m(0,2)^2*m(0,1) + 2*m(0,1)^3)/sdev_p_b^3;
    skew_dif = (m(3,0)-3*m(2,1)+3*m(1,2)-m(0,3)-3*mean_dif*sdev_dif^2-mean_dif^3)/sdev_dif^3;
    key      = [mean_p_b mean_p_w -mean_dif ; ...
                sdev_p_b sdev_p_w  sdev_dif ; ...
                corr_p_b corr_p_w -corr_dif ; ...
                skew_p_b skew_p_w -skew_dif];

    centered = mc;
    key      = key(:);
end
